#include <iostream>

class Lock {
public:
	Lock() { std::cout << "locked\n"; }

	// Rule of Three:
	// This class manages a resource (a lock) and therefore
	// has to define (or explicitly delete) all of the following:
	// - copy constructor
	// - copy assignment operator
	// - destructor

	Lock(const Lock&) = delete;
	Lock& operator=(const Lock&) = delete;
	~Lock() { std::cout << "unlocked\n"; }
};

void doSomethingCritical() {
	Lock lock;
	std::cout << "critical section\n";
}

int main() {
	doSomethingCritical();
}
